--
-- Iveco Crane Working Script
--
-- by Zippo
-- 


ICrane = {}

function ICrane.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return true;
end;

function ICrane:load(xmlFile)
	
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;

local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
        if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end; 

local translationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart3#index"));
        if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end;
        local translationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart4#index"));
        if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 2)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end;
        local translationPartNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart5#index"));
        if translationPartNode5 ~= nil then
        self.translationPart5 = {};
        self.translationPart5.node = translationPartNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#minTrans"));
        self.translationPart5.minTrans = {};
        self.translationPart5.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#maxTrans"));
        self.translationPart5.maxTrans = {};
        self.translationPart5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#transTime"), 2)*1000;
        self.translationPart5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#touchTransLimit"), 10);
    end;
        local translationPartNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart6#index"));
        if translationPartNode6 ~= nil then
        self.translationPart6 = {};
        self.translationPart6.node = translationPartNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#minTrans"));
        self.translationPart6.minTrans = {};
        self.translationPart6.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#maxTrans"));
        self.translationPart6.maxTrans = {};
        self.translationPart6.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart6.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#transTime"), 2)*1000;
        self.translationPart6.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#touchTransLimit"), 10);
    end;
local translationPartNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart7#index"));
        if translationPartNode7 ~= nil then
        self.translationPart7 = {};
        self.translationPart7.node = translationPartNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#minTrans"));
        self.translationPart7.minTrans = {};
        self.translationPart7.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#maxTrans"));
        self.translationPart7.maxTrans = {};
        self.translationPart7.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart7.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#transTime"), 2)*1000;
        self.translationPart7.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#touchTransLimit"), 10);
    end; 

local translationPartNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart8#index"));
        if translationPartNode8 ~= nil then
        self.translationPart8 = {};
        self.translationPart8.node = translationPartNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#minTrans"));
        self.translationPart8.minTrans = {};
        self.translationPart8.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#maxTrans"));
        self.translationPart8.maxTrans = {};
        self.translationPart8.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart8.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#transTime"), 2)*1000;
        self.translationPart8.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#touchTransLimit"), 10);
    end;
        local translationPartNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart9#index"));
        if translationPartNode9 ~= nil then
        self.translationPart9 = {};
        self.translationPart9.node = translationPartNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#minTrans"));
        self.translationPart9.minTrans = {};
        self.translationPart9.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#maxTrans"));
        self.translationPart9.maxTrans = {};
        self.translationPart9.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart9.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#transTime"), 2)*1000;
        self.translationPart9.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#touchTransLimit"), 10);
    end;
        local translationPartNode10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart10#index"));
        if translationPartNode10 ~= nil then
        self.translationPart10 = {};
        self.translationPart10.node = translationPartNode10;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart10#minTrans"));
        self.translationPart10.minTrans = {};
        self.translationPart10.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart10.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart10.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart10#maxTrans"));
        self.translationPart10.maxTrans = {};
        self.translationPart10.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart10.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart10.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart10.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart10#transTime"), 2)*1000;
        self.translationPart10.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart10#touchTransLimit"), 10);
    end;
        local translationPartNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart11#index"));
        if translationPartNode11 ~= nil then
        self.translationPart11 = {};
        self.translationPart11.node = translationPartNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart11#minTrans"));
        self.translationPart11.minTrans = {};
        self.translationPart11.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart11.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart11.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart11#maxTrans"));
        self.translationPart11.maxTrans = {};
        self.translationPart11.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart11.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart11.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart11.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart11#transTime"), 2)*1000;
        self.translationPart11.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart11#touchTransLimit"), 10);
    end;
local translationPartNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart12#index"));
        if translationPartNode12 ~= nil then
        self.translationPart12 = {};
        self.translationPart12.node = translationPartNode12;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart12#minTrans"));
        self.translationPart12.minTrans = {};
        self.translationPart12.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart12.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart12.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart12#maxTrans"));
        self.translationPart12.maxTrans = {};
        self.translationPart12.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart12.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart12.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart12.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart12#transTime"), 2)*1200;
        self.translationPart12.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart12#touchTransLimit"), 10);
    end;
        local translationPartNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart13#index"));
        if translationPartNode13 ~= nil then
        self.translationPart13 = {};
        self.translationPart13.node = translationPartNode13;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart13#minTrans"));
        self.translationPart13.minTrans = {};
        self.translationPart13.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart13.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart13.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart13#maxTrans"));
        self.translationPart13.maxTrans = {};
        self.translationPart13.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart13.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart13.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart13.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart13#transTime"), 2)*1000;
        self.translationPart13.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart13#touchTransLimit"), 10);
    end;
local translationPartNode14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart14#index"));
        if translationPartNode14 ~= nil then
        self.translationPart14 = {};
        self.translationPart14.node = translationPartNode14;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart14#minTrans"));
        self.translationPart14.minTrans = {};
        self.translationPart14.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart14.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart14.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart14#maxTrans"));
        self.translationPart14.maxTrans = {};
        self.translationPart14.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart14.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart14.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart14.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart14#transTime"), 2)*1000;
        self.translationPart14.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart14#touchTransLimit"), 10);
    end;
local translationPartNode15 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart15#index"));
        if translationPartNode15 ~= nil then
        self.translationPart15 = {};
        self.translationPart15.node = translationPartNode15;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart15#minTrans"));
        self.translationPart15.minTrans = {};
        self.translationPart15.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart15.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart15.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart15#maxTrans"));
        self.translationPart15.maxTrans = {};
        self.translationPart15.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart15.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart15.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart15.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart15#transTime"), 2)*1000;
        self.translationPart15.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart15#touchTransLimit"), 10);
    end;


        local translationHookNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHook#index"));
    if translationHookNode ~= nil then
        self.translationHook = {};
        self.translationHook.node = translationHookNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHook#minTrans"));
        self.translationHook.minTrans = {};
        self.translationHook.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHook.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHook.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHook#maxTrans"));
        self.translationHook.maxTrans = {};
        self.translationHook.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHook.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHook.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHook.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHook#transTime"), 2)*1000;
        self.translationHook.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHook#touchTransLimit"), 10);
    end;        

        local translationHydNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd#index"));
    if translationHydNode ~= nil then
        self.translationHyd = {};
        self.translationHyd.node = translationHydNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd#minTrans"));
        self.translationHyd.minTrans = {};
        self.translationHyd.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd#maxTrans"));
        self.translationHyd.maxTrans = {};
        self.translationHyd.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd#transTime"), 2)*1000;
        self.translationHyd.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd#touchTransLimit"), 10);
    end;
    
	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;
    local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
        self.rotation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#touchRotLimit"), 10));
    end;
    
      local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation4#index"));
    if rotationNode4 ~= nil then
        self.rotation4 = {};
        self.rotation4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#minRot"));
        self.rotation4.minRot = {};
        self.rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#maxRot"));
        self.rotation4.maxRot = {};
        self.rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#rotTime"), 2)*1000;
        self.rotation4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#touchRotLimit"), 10));
    end;
 
         local rotationNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
        self.rotation5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#touchRotLimit"), 10));
    end;
 
	local rotationNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation6#index"));
    if rotationNode6 ~= nil then
        self.rotation6 = {};
        self.rotation6.node = rotationNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#minRot"));
        self.rotation6.minRot = {};
        self.rotation6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#maxRot"));
        self.rotation6.maxRot = {};
        self.rotation6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#rotTime"), 2)*1000;
        self.rotation6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#touchRotLimit"), 10));
    end;

local rotationNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation7#index"));
    if rotationNode7 ~= nil then
        self.rotation7 = {};
        self.rotation7.node = rotationNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#minRot"));
        self.rotation7.minRot = {};
        self.rotation7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#maxRot"));
        self.rotation7.maxRot = {};
        self.rotation7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#rotTime"), 2)*1000;
        self.rotation7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#touchRotLimit"), 10));
    end;

    local rotationNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation8#index"));
    if rotationNode8 ~= nil then
        self.rotation8 = {};
        self.rotation8.node = rotationNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#minRot"));
        self.rotation8.minRot = {};
        self.rotation8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#maxRot"));
        self.rotation8.maxRot = {};
        self.rotation8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation8#rotTime"), 2)*1000;
        self.rotation8.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation8#touchRotLimit"), 10));
    end;

local rotationNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation9#index"));
    if rotationNode9 ~= nil then
        self.rotation9 = {};
        self.rotation9.node = rotationNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#minRot"));
        self.rotation9.minRot = {};
        self.rotation9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#maxRot"));
        self.rotation9.maxRot = {};
        self.rotation9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation9#rotTime"), 2)*1000;
        self.rotation9.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation9#touchRotLimit"), 10));
    end;

    local rotationNode10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation10#index"));
    if rotationNode10 ~= nil then
        self.rotation10 = {};
        self.rotation10.node = rotationNode10;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation10#minRot"));
        self.rotation10.minRot = {};
        self.rotation10.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation10.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation10.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation10#maxRot"));
        self.rotation10.maxRot = {};
        self.rotation10.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation10.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation10.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation10.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation10#rotTime"), 2)*1000;
        self.rotation10.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation10#touchRotLimit"), 10));
    end;


hydra1SoundFile = Utils.getFilename("sounds/hydra1.wav", self.baseDirectory);
    self.hydra1SoundId = createSample("HYD1_hydra1");
    loadSample(self.hydra1SoundId, hydra1SoundFile, false);
    self.hydra1Playing = false;
    
hydra2SoundFile = Utils.getFilename("sounds/hydra2.wav", self.baseDirectory);
    self.hydra2SoundId = createSample("HYD2_hydra2");
    loadSample(self.hydra2SoundId, hydra2SoundFile, false);
    self.hydra2Playing = false;

hydra3SoundFile = Utils.getFilename("sounds/hydra3.wav", self.baseDirectory);
    self.hydra3SoundId = createSample("HYD3_hydra3");
    loadSample(self.hydra3SoundId, hydra3SoundFile, false);
    self.hydra3Playing = false;

hydraRotSoundFile = Utils.getFilename("sounds/hydraRot.wav", self.baseDirectory);
    self.hydraRotSoundId = createSample("HYDRot_hydraRot");
    loadSample(self.hydraRotSoundId, hydraRotSoundFile, false);
    self.hydraRotPlaying = false;
    
hydraRotBSoundFile = Utils.getFilename("sounds/hydraRotB.wav", self.baseDirectory);
    self.hydraRotBSoundId = createSample("HYDRotB_hydraRotB");
    loadSample(self.hydraRotBSoundId, hydraRotBSoundFile, false);
    self.hydraRotBPlaying = false;    

end;
      
function ICrane:delete()
end;

function ICrane:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function ICrane:keyEvent(unicode, sym, modifier, isDown)

    if sym == Input.KEY_KP_9 then
		self.translationMin2 = isDown;
self.translationMin3 = isDown;
self.translationMin4 = isDown;
self.translationMin5 = isDown;
self.translationMin6 = isDown;
self.translationMin7 = isDown;
self.translationMin8 = isDown;
self.translationMin9 = isDown;
self.translationMin10 = isDown;
self.translationMin11 = isDown;
self.translationMin12 = isDown;
self.translationMin13 = isDown;
self.translationMin14 = isDown;
self.translationMin15 = isDown;
		
	end;
	if sym == Input.KEY_KP_6 then
		self.translationMax2 = isDown;
self.translationMax3 = isDown;
self.translationMax4 = isDown;
self.translationMax5 = isDown;
self.translationMax6 = isDown;
self.translationMax7 = isDown;
self.translationMax8 = isDown;
self.translationMax9 = isDown;
self.translationMax10 = isDown;
self.translationMax11 = isDown;
self.translationMax12 = isDown;
self.translationMax13 = isDown;
self.translationMax14 = isDown;
self.translationMax15 = isDown;

		
	end;
	if sym == Input.KEY_KP_4 then
		self.rotation2Min = isDown;
		
	end;
	if sym == Input.KEY_KP_7 then
		self.rotation2Max = isDown;
		
	end;
	if sym == Input.KEY_KP_8 then
		self.rotation3Min = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.rotation3Max = isDown;
	end;
	if sym == Input.KEY_KP_1 then
		self.rotation1Max = isDown;
	end;
	if sym == Input.KEY_KP_3 then
		self.rotation1Min = isDown;
	end;
if sym == Input.KEY_KP_0 then
		self.translationMin = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.translationMax = isDown;
	end;
	
	
end;

function ICrane:update(dt)
	
	local doTranslate = self.translationMax or self.translationMin 
	if self.translationPart ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax); 
		setTranslation(self.translationPart.node, unpack(newTrans)); 
	end; 

local doTranslate = self.translationMax2 or self.translationMin2 
	if self.translationPart2 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2); 
		setTranslation(self.translationPart2.node, unpack(newTrans)); 
	end;
	
local doTranslate = self.translationMax3 or self.translationMin3 
	if self.translationPart3 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime, dt, not self.translationMax3); 
		setTranslation(self.translationPart3.node, unpack(newTrans)); 
        end;
	local doTranslate = self.translationMax4 or self.translationMin4 
	if self.translationPart4 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart4.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime, dt, not self.translationMax4); 
		setTranslation(self.translationPart4.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax5 or self.translationMin5 
	if self.translationPart5 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart5.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart5.maxTrans, self.translationPart5.minTrans, 3, self.translationPart5.transTime, dt, not self.translationMax5); 
		setTranslation(self.translationPart5.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax6 or self.translationMin6 
	if self.translationPart6 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart6.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart6.maxTrans, self.translationPart6.minTrans, 3, self.translationPart6.transTime, dt, not self.translationMax6); 
		setTranslation(self.translationPart6.node, unpack(newTrans)); 
	end;

local doTranslate = self.translationMax7 or self.translationMin7 
	if self.translationPart7 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart7.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart7.maxTrans, self.translationPart7.minTrans, 3, self.translationPart7.transTime, dt, not self.translationMax7); 
		setTranslation(self.translationPart7.node, unpack(newTrans)); 
	end;
	
local doTranslate = self.translationMax8 or self.translationMin8 
	if self.translationPart8 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart8.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart8.maxTrans, self.translationPart8.minTrans, 3, self.translationPart8.transTime, dt, not self.translationMax8); 
		setTranslation(self.translationPart8.node, unpack(newTrans)); 
        end;
	local doTranslate = self.translationMax9 or self.translationMin9 
	if self.translationPart9 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart9.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart9.maxTrans, self.translationPart9.minTrans, 3, self.translationPart9.transTime, dt, not self.translationMax9); 
		setTranslation(self.translationPart9.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax10 or self.translationMin10 
	if self.translationPart10 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart10.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart10.maxTrans, self.translationPart10.minTrans, 3, self.translationPart10.transTime, dt, not self.translationMax10); 
		setTranslation(self.translationPart10.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax11 or self.translationMin11 
	if self.translationPart11 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart11.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart11.maxTrans, self.translationPart11.minTrans, 3, self.translationPart11.transTime, dt, not self.translationMax11); 
		setTranslation(self.translationPart11.node, unpack(newTrans)); 
	end;

local doTranslate = self.translationMax12 or self.translationMin12 
	if self.translationPart12 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart12.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart12.maxTrans, self.translationPart12.minTrans, 3, self.translationPart12.transTime, dt, not self.translationMax12); 
		setTranslation(self.translationPart12.node, unpack(newTrans)); 
	end;
	
local doTranslate = self.translationMax13 or self.translationMin13 
	if self.translationPart13 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart13.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart13.maxTrans, self.translationPart13.minTrans, 3, self.translationPart13.transTime, dt, not self.translationMax13); 
		setTranslation(self.translationPart13.node, unpack(newTrans)); 
        end;
	local doTranslate = self.translationMax14 or self.translationMin14 
	if self.translationPart14 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart14.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart14.maxTrans, self.translationPart14.minTrans, 3, self.translationPart14.transTime, dt, not self.translationMax14); 
		setTranslation(self.translationPart14.node, unpack(newTrans)); 
	end;
local doTranslate = self.translationMax15 or self.translationMin15 
	if self.translationPart15 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart15.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart15.maxTrans, self.translationPart15.minTrans, 3, self.translationPart15.transTime, dt, not self.translationMax15); 
		setTranslation(self.translationPart15.node, unpack(newTrans)); 
	end;


	local doTranslate = self.translationHookMax or self.translationHookMin 
	if self.translationHook ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHook.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHook.maxTrans, self.translationHook.minTrans, 3, self.translationHook.transTime, dt, not self.translationHookMax); 
		setTranslation(self.translationHook.node, unpack(newTrans)); 
	end;	

	local doTranslate = self.translationHydMax or self.translationHydMin 
	if self.translationHyd ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd.maxTrans, self.translationHyd.minTrans, 3, self.translationHyd.transTime, dt, not self.translationHydMax); 
		setTranslation(self.translationHyd.node, unpack(newTrans)); 
	end;

	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
        if not self.hydra1Playing then
            playSample(self.hydra1SoundId, 0, 1, 0);
            self.hydra1Playing = true;
        end;
    else
        if self.hydra1Playing then
            stopSample(self.hydra1SoundId);
            self.hydra1Playing = false;
        end;
    end;
	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
        if not self.hydra2Playing then
            playSample(self.hydra2SoundId, 0, 1, 0);
            self.hydra2Playing = true;
        end;
    else
        if self.hydra2Playing then
            stopSample(self.hydra2SoundId);
            self.hydra2Playing = false;
        end;
    end;
    
    local doRotate = self.rotation3Max or self.rotation3Min 
	if self.rotation3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
    end;
    
       local doRotate = self.rotation4Max or self.rotation4Min 
	if self.rotation4 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation4.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation4.maxRot, self.rotation4.minRot, 3, self.rotation4.rotTime, dt, not self.rotation4Max);
        setRotation(self.rotation4.node, unpack(newRot));
        if not self.hydra3Playing then
            playSample(self.hydra3SoundId, 0, 1, 0);
            self.hydra3Playing = true;
        end;
    else
        if self.hydra3Playing then
            stopSample(self.hydra3SoundId);
            self.hydra3Playing = false;
        end;
    end;
	
	   local doRotate = self.rotation5Max or self.rotation5Min 
	if self.rotation5 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
        setRotation(self.rotation5.node, unpack(newRot));
        if not self.hydraRotBPlaying then
            playSample(self.hydraRotBSoundId, 0, 1, 0);
            self.hydraRotBPlaying = true;
        end;
    else
        if self.hydraRotBPlaying then
            stopSample(self.hydraRotBSoundId);
            self.hydraRotBPlaying = false;
        end;
    end;
	
	local doRotate = self.rotation6Max or self.rotation6Min 
	if self.rotation6 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation6.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation6.maxRot, self.rotation6.minRot, 3, self.rotation6.rotTime, dt, not self.rotation6Max);
        setRotation(self.rotation6.node, unpack(newRot));
        if not self.hydraRotPlaying then
            playSample(self.hydraRotSoundId, 0, 1, 0);
            self.hydraRotPlaying = true;
        end;
    else
        if self.hydraRotPlaying then
            stopSample(self.hydraRotSoundId);
            self.hydraRotPlaying = false;
        end;
    end;

local doRotate = self.rotation7Max or self.rotation7Min 
	if self.rotation7 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation7.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation7.maxRot, self.rotation7.minRot, 3, self.rotation7.rotTime, dt, not self.rotation7Max);
        setRotation(self.rotation7.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation8Max or self.rotation8Min 
	if self.rotation8 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation8.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation8.maxRot, self.rotation8.minRot, 3, self.rotation8.rotTime, dt, not self.rotation8Max);
        setRotation(self.rotation8.node, unpack(newRot));
    end;

local doRotate = self.rotation9Max or self.rotation9Min 
	if self.rotation9 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation9.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation9.maxRot, self.rotation9.minRot, 3, self.rotation9.rotTime, dt, not self.rotation9Max);
        setRotation(self.rotation9.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation10Max or self.rotation10Min 
	if self.rotation10 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation10.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation10.maxRot, self.rotation10.minRot, 3, self.rotation10.rotTime, dt, not self.rotation10Max);
        setRotation(self.rotation10.node, unpack(newRot));
    end;
end;

function ICrane:draw()
end;

function ICrane:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
